Loading...
Searching...
No Matches
Sip_via

## Data Structures

struct | sip_via_s
| Structure for Via header field. More...

## Macros

#define | sip_via(sip)
| Access a SIP Via header structure sip_via_t from sip_t.
#define | SIP_VIA_INIT()
| Initializer for structure sip_via_t.
#define | SIPTAG_VIA(x)
| Tag list item for pointer to a Via header structure sip_via_t.
#define | SIPTAG_VIA_REF(x)
| Tag list item for reference to a Via header pointer.
#define | SIPTAG_VIA_STR(s)
| Tag list item for string with Via header value.
#define | SIPTAG_VIA_STR_REF(x)
| Tag list item for reference to a Via header string.

## Typedefs

typedef struct sip_via_s | sip_via_t
| @

## Functions

issize_t | sip_via_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Via header.
issize_t | sip_via_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Via header.
sip_via_t * | sip_via_init (sip_via_t x[1])
| Initialize a structure sip_via_t.
int | sip_is_via (sip_header_t const *header)
| Test if header object is instance of sip_via_t.
sip_via_t * | sip_via_dup (su_home_t *home, sip_via_t const *hdr))
| Duplicate a list of Via header header structures sip_via_t.
sip_via_t * | sip_via_copy (su_home_t *home, sip_via_t const *hdr))
| Copy a list of Via header header structures sip_via_t.
sip_via_t * | sip_via_make (su_home_t *home, char const *s))
| Make a Via header structure sip_via_t.
sip_via_t * | sip_via_format (su_home_t *home, char const *fmt,...)))
| Make a Via header from formatting result.
int | sip_via_add_param (su_home_t *home, sip_via_t *v, char const *param)
| Add a parameter to a Via object.
sip_via_t * | sip_via_create (su_home_t *home, char const *host, char const *port, char const *transport,...)
| Create a Via object.
char const * | sip_via_port (sip_via_t const *v, int *using_rport)
| Get port number corresponding to a Via line.
sip_via_t * | sip_via_remove (msg_t *msg, sip_t *sip)
| Get first via header and remove it from its fragment chain.

## Variables

msg_hclass_t | sip_via_class []
| Header class for Via header.
tag_typedef_t | siptag_via
| Tag for Via header object.
tag_typedef_t | siptag_via_str
| Tag for string with Via header value.

## Detailed Description

## Macro Definition Documentation

## SIP_VIA_INIT

#define SIP_VIA_INIT | ( |  | ) |

Initializer for structure sip_via_t.

A static sip_via_t structure for Via header must be initialized with the SIP_VIA_INIT() macro. For instance,

sip_via_t sip_via = SIP_VIA_INIT;
sip_via
#define sip_via(sip)
Access a SIP Via header structure sip_via_t from sip_t.
Definition sip_protos.h:607
SIP_VIA_INIT
#define SIP_VIA_INIT()
Initializer for structure sip_via_t.
Definition sip_protos.h:624
sip_via_t
struct sip_via_s sip_via_t
@
Definition sip.h:200

## SIPTAG_VIA

#define SIPTAG_VIA | ( |  | x | ) |

Tag list item for pointer to a Via header structure sip_via_t.

The SIPTAG_VIA() macro is used to include a tag item with a pointer to a sip_via_t structure in a tag list.

Parameters

  x | pointer to a sip_via_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_VIA_REF().

## SIPTAG_VIA_STR

#define SIPTAG_VIA_STR | ( |  | s | ) |

Tag list item for string with Via header value.

The SIPTAG_VIA_STR() macro is used to include a tag item with a string containing value of a sip_via_t header in a tag list.

Parameters

  s | pointer to a string containing Via header value, or NULL.

The string in SIPTAG_VIA_STR() can be converted to a sip_via_t header structure by giving the string s has second argument to function sip_via_make().

The corresponding tag taking reference parameter is SIPTAG_VIA_STR_REF().

## Typedef Documentation

## sip_via_t

typedef struct sip_via_s sip_via_t

@

The Via header indicates the path taken by the request so far. Via headers can be used to prevent request looping and ensure replies take the same path as the requests. The Via syntax is defined in RFC 3261 as follows:

Via = ( "Via" / "v" ) HCOLON via-parm *(COMMA via-parm)
via-parm = sent-protocol LWS sent-by *( SEMI via-params )
via-params = via-ttl / via-maddr
/ via-received / via-branch
/ via-extension
via-ttl = "ttl" EQUAL ttl
via-maddr = "maddr" EQUAL host
via-received = "received" EQUAL (IPv4address / IPv6address)
via-branch = "branch" EQUAL token
via-extension = generic-param
sent-protocol = protocol-name SLASH protocol-version
SLASH transport
protocol-name = "SIP" / token
protocol-version = token
transport = "UDP" / "TCP" / "TLS" / "SCTP"
/ other-transport
sent-by = host [ COLON port ]
ttl = 1*3DIGIT ; 0 to 255
DIGIT
#define DIGIT
LWS
#define LWS

Note
  The RFC 2543 syntax allowed <comment>. We accept it, but don't encode it.

In addition to the parameters defined in RFC 3261, RFC 3486 defines a parameter "comp":

via-compression = "comp" EQUAL ("sigcomp" / other-compression)
via-params /= via-compression

RFC 3581 defines a parameter "rport":

response-port = "rport" [EQUAL 1*DIGIT]
via-params /= response-port

The parsed Via header is stored in sip_via_t structure.

The structure sip_via_t contains representation of SIP Via header.

The sip_via_t is defined as follows:

typedef struct sip_via_s {
sip_common_t v_common[1]; // Common fragment info
sip_via_t *v_next; // Link to next @Via header
char const *v_protocol; // Application and transport protocol
char const *v_host; // Hostname
char const *v_port; // Port number
msg_param_t const *v_params; // List of via-params
char const *v_comment; // Comment
char const *v_ttl; // "ttl" parameter
char const *v_maddr; // "maddr" parameter
char const *v_received; // "received" parameter
char const *v_branch; // "branch" parameter
char const *v_comp; // "comp" parameter
char const *v_rport; // "rport" parameter
} sip_via_t;
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_via_s
Structure for Via header field.
Definition sip.h:753
sip_via_s::v_next
sip_via_t * v_next
Link to next Via header.
Definition sip.h:755
sip_via_s::v_comp
char const * v_comp
Value of "comp" parameter.
Definition sip.h:766
sip_via_s::v_port
char const * v_port
Port number.
Definition sip.h:758
sip_via_s::v_params
msg_param_t const * v_params
List of via-params.
Definition sip.h:759
sip_via_s::v_protocol
char const * v_protocol
Application and transport protocol.
Definition sip.h:756
sip_via_s::v_rport
char const * v_rport
Value of "rport" parameter.
Definition sip.h:765
sip_via_s::v_ttl
char const * v_ttl
Value of "ttl" parameter.
Definition sip.h:761
sip_via_s::v_common
sip_common_t v_common[1]
Common fragment info.
Definition sip.h:754
sip_via_s::v_comment
char const * v_comment
Comment.
Definition sip.h:760
sip_via_s::v_host
char const * v_host
Hostname.
Definition sip.h:757
sip_via_s::v_maddr
char const * v_maddr
Value of "maddr" parameter.
Definition sip.h:762
sip_via_s::v_branch
char const * v_branch
Value of "branch" parameter.
Definition sip.h:764
sip_via_s::v_received
char const * v_received
Value of "received" parameter.
Definition sip.h:763

## Function Documentation

## sip_is_via()

int sip_is_via | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_via_t.

Check if the header class is an instance of Via header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header via
  0 | (false) otherwise

## sip_via_add_param()

int sip_via_add_param | ( | su_home_t * | home,
|  | sip_via_t * | v,
|  | char const * | param )

Add a parameter to a Via object.

Add a parameter to a Via header object.

Note
  This function does not duplicate `param`.

Parameters

  home | memory home
  v | sip_via_t object
  param | parameter string

Return values

  0 | when successful
  -1 | upon an error.

Deprecated
  Use msg_header_replace_param() directly.

## sip_via_copy()

sip_via_t * sip_via_copy | ( | su_home_t * | home,
|  | sip_via_t const * | hdr )

inline

Copy a list of Via header header structures sip_via_t.

The function sip_via_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  via = sip_via_copy(home, sip->sip_via);
  sip_via_copy
  sip_via_t * sip_via_copy(su_home_t *home, sip_via_t const *hdr))
  Copy a list of Via header header structures sip_via_t.
  Definition sip_protos.h:754

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_via_create()

sip_via_t * sip_via_create | ( | su_home_t * | home,
|  | char const * | host,
|  | char const * | port,
|  | char const * | transport,
|  |  | ... )

Create a Via object.

Create a new Via header object with given parameters. If transport is NULL, the default transport "SIP/2.0/UDP" is used. A NULL-terminated list of parameters can be specified after transport.

Parameters

  home | memory home
  host | host name
  port | protocol port number
  transport | transport protocol (default is "SIP/2.0/UDP")
  ... | NULL-terminated list of parameters

Returns
  A pointer to newly created Via header object when successful or NULL upon an error.

## sip_via_dup()

sip_via_t * sip_via_dup | ( | su_home_t * | home,
|  | sip_via_t const * | hdr )

inline

Duplicate a list of Via header header structures sip_via_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  via = sip_via_dup(home, sip->sip_via);
  sip_via_dup
  sip_via_t * sip_via_dup(su_home_t *home, sip_via_t const *hdr))
  Duplicate a list of Via header header structures sip_via_t.
  Definition sip_protos.h:711

Returns
  A pointer to the newly duplicated sip_via_t header structure, or NULL upon an error.

## sip_via_format()

sip_via_t * sip_via_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Via header from formatting result.

Make a new sip_via_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_via_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_via_init()

sip_via_t * sip_via_init | ( | sip_via_t | x[1] | ) |

inline

Initialize a structure sip_via_t.

An sip_via_t structure for Via header can be initialized with the sip_via_init() function/macro. For instance,

sip_via_t sip_via;
sip_via_init(&sip_via);
sip_via_init
sip_via_t * sip_via_init(sip_via_t x[1])
Initialize a structure sip_via_t.
Definition sip_protos.h:642

## sip_via_make()

sip_via_t * sip_via_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Via header structure sip_via_t.

The function sip_via_make() makes a new sip_via_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_via_t header structure, or NULL upon an error.

## sip_via_port()

char const * sip_via_port | ( | sip_via_t const * | v,
|  | int * | using_rport )

Get port number corresponding to a Via line.

If using_rport is non-null, try rport. If *using_rport is non-zero, try rport even if <protocol> is not UDP. If <protocol> is UDP, set *using_rport to zero.

## Variable Documentation

## sip_via_class

msg_hclass_t sip_via_class[]

extern

Header class for Via header.

The header class sip_via_class defines how a SIP Via header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_via_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.